Subject: RE: Cygwin Python -- Thread or not to thread...
From: "Tim Peters" <[email-masked]>
To: "Cygwin" <[email-masked]>
Cc: "Python-List" <[email-masked]>
Date: Tue, 25 Sep 2001 17:17:47 -0400

[Jason Tishler]
> ...
> there is one known Cygwin pthreads race condition that can cause a hang,
> ...
> test_threadedtempfile hung due to the above mentioned problem.
> ...
>     Should I still release my next Cygwin Python distribution with
>     threading enabled?  Or, should I continue to disabled threading
>     until the above known Cygwin pthreads issue is resolved?

Poor end users should never need to deal with thread race bugs, and
test_threadedtempfile is merely testing the robustness of a Python library
routine in the presence of threads.  So a user can get burned by this
through no fault of their own -- tempfile.TemporaryFile() is meant to be
used by everyone, threads or not.

> ...
> By releasing a threaded Cygwin Python, more people will be able to
> exercise Cygwin's pthreads support which will help test the
> implementation.

If it's already known to be flawed, what's the point in having millions of
users confirm it <wink>?

> ...
> The more conservative approach is to continue to release Cygwin Python
> with threading disabled until the known Cygwin pthreads issue is
> resolved.

AKA "the user-friendly" approach.  Spell out in the README that users who
don't mind losing their hair are encouraged to build and test with thread
support enabled.  A few will, most won't, and that's how it should be when
it's known to be buggy; the good news is that the few who do try it will be
much more likely to be motivated and helpful.

the-2.1.1-release-was-meant-to-be-rock-solid-ly y'rs  - tim

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/